// InputCMT.cpp: CInputCMT NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "vjb30040.h"
#include "InputCMT.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CInputCMT::CInputCMT()
{
	int nHAdapter, nScsiID, nScsiLUN;

	// INIt@CCMT̐ݒ擾
	nHAdapter = GetIniData("CMT", "HAdapter", 0);
	nScsiID = GetIniData("CMT", "ScsiID", 0);
	nScsiLUN = GetIniData("CMT", "ScsiLUN", 0);

	// CMTuI[v
	if (m_MTDriver.Open(nHAdapter, nScsiID, nScsiLUN) == 0)
		m_bOpen = TRUE;
	else
		m_bOpen = FALSE;
}

CInputCMT::~CInputCMT()
{
	// CMTuN[Y
	if (m_bOpen)
		m_MTDriver.Close();
}

//
//	@\	F@smFbZ[W
//
//		F	pParam - ̓p[^
//
//	Al	F	ʃR[h
//
//	@\F	smFbZ[W\AIy[^̎x҂B
//
//	l	F	
//
int CInputCMT::KakuninMessage(Param *pParam)
{
	CString sFirstVolLabel;

	// ŏ̃{[o
	sFirstVolLabel = pParam->sVolLabel.SpanExcluding(",");

	if (pParam->bLabel) {
		// xL̊mFbZ[W
		if (DispMessage(IDS_MSG_DEVICE_SET2, MB_OKCANCEL, FALSE,
				pParam->sShubetsuCode, pParam->sShikibetsuCode, sFirstVolLabel) == IDCANCEL)
			return RC_CANCEL;
	} else {
		// x̊mFbZ[W
		if (DispMessage(IDS_MSG_DEVICE_SET3, MB_OKCANCEL, FALSE,
				pParam->sShubetsuCode, pParam->sShikibetsuCode, sFirstVolLabel) == IDCANCEL)
			return RC_CANCEL;
	}

	return RC_NORMAL;
}

//
//	@\	F@{[x`FbN
//
//		F	pParam - ̓p[^
//
//	Al	F	ʃR[h
//
//	@\F	͂ꂽ{[xƔ}̂̃{[xv邩`FbNB
//
//	l	F	
//
int CInputCMT::CheckVolumeName(Param *pParam)
{
	CString sFirstVolLabel;
	CString sReadVolLabel;

	// CMTuI[vĂȂ΃G[
	if (!m_bOpen)
		return RC_IOERROR;

	if (pParam->bLabel) {
		// ŏ̃{[o
		sFirstVolLabel = pParam->sVolLabel.SpanExcluding(",");

		// CMT{[擾
		if (m_MTDriver.ReadVolumeLabel(sReadVolLabel) != 0)
			return RC_IOERROR;

		// v`FbN
		if (sReadVolLabel != sFirstVolLabel)
			return RC_VOLUMENAME;
	}

	return RC_NORMAL;
}

//
//	@\	F@}̓͏
//
//		F	pParam - ̓p[^
//
//	Al	F	ʃR[h
//
//	@\F	}̂t@C͂B
//
//	l	F	
//
int CInputCMT::InputFiles(Param *pParam)
{
	CString sDstDir;
	int nResult;

	// CMTuI[vĂȂ΃G[
	if (!m_bOpen)
		return RC_IOERROR;

	// Rs[fBNg擾
	sDstDir = CreatePathName(g_sInputDir,
			pParam->sShikibetsuCode + (pParam->bLabel ? pParam->sVolLabel.SpanExcluding(",") : "000000"));

	// Rs[fBNg폜
	DeleteDirectory(sDstDir, FALSE);

	// Rs[fBNg쐬
	CreateDirectory(sDstDir, NULL);

	// tbVEBhEݒ
	m_MTDriver.m_pUpdateWnd = m_pUpdateWnd;

	// xL薳ŏ𕪂
	if (pParam->bLabel)
		nResult = InputFilesWithLabel(pParam, sDstDir);
	else
		nResult = InputFilesNonLabel(pParam, sDstDir);

	return nResult;
}

//
//	@\	F@x͏
//
//		F	pParam - ̓p[^
//				pDirName - ͐fBNg
//
//	Al	F	ʃR[h
//
//	@\F	xCMTt@C͂B
//
//	l	F	
//
int CInputCMT::InputFilesWithLabel(Param *pParam, LPCTSTR pDirName)
{
	CString sVolLabel;
	CString sCurrentVolLabel;
	CString sReadVolLabel;
	BOOL bFirst = TRUE;
	int nResult;

	sVolLabel = pParam->sVolLabel;
	while (sVolLabel.GetLength() != 0) {
		// Jg{[xo
		sCurrentVolLabel = sVolLabel.SpanExcluding(",");

		if (bFirst)
			bFirst = FALSE;
		else {
			// Q߂̃{[ȍ~̊mFbZ[W
			if (DispMessage(IDS_MSG_DEVICE_SET2, MB_OKCANCEL, FALSE,
					pParam->sShubetsuCode, pParam->sShikibetsuCode, sCurrentVolLabel) == IDCANCEL)
				return RC_CANCEL;
		}

		while (true) {
			// CMT{[x擾
			if (m_MTDriver.ReadVolumeLabel(sReadVolLabel) != 0)
				return RC_IOERROR;

			// {[xv`FbN
			if (sReadVolLabel != sCurrentVolLabel) {
				m_MTDriver.Unload();
				if (DispMessage(IDS_MSG_DIFF_VOLLABEL2, MB_RETRYCANCEL, FALSE,
						sReadVolLabel, sCurrentVolLabel) == IDCANCEL) {
					return RC_CANCEL;
				}
			} else
				break;
		}

		// CMTt@CɃRs[
		if ((nResult = m_MTDriver.ReadFileWithLabel(pDirName)) < 0 || nResult == RESULT_FILE_ERROR)
			return RC_IOERROR;
		else if (nResult != RESULT_VOLUME_END)
			break;

		// ̃{[xɈړ
		sVolLabel = sVolLabel.Mid(min(sCurrentVolLabel.GetLength() + 1, sVolLabel.GetLength()));
	}

	return RC_NORMAL;
}


//
//	@\	F@x͏
//
//		F	pParam - ̓p[^
//				pDirName - ͐fBNg
//
//	Al	F	ʃR[h
//
//	@\F	xCMTt@C͂B
//
//	l	F	
//
int CInputCMT::InputFilesNonLabel(Param *pParam, LPCTSTR pDirName)
{
	CString sVolLabel;
	CString sCurrentVolLabel;
	CString sFileName;
	CString sTemp;
	int nRecordLength;
	int nVolume;
	int nNextPos;
	BOOL bBOT = FALSE;
	int nVolCount = 0;
	BOOL bLoop = TRUE;
	int i;
	int nResult;

	sVolLabel = pParam->sVolLabel;
	while (sVolLabel.GetLength() != 0 && bLoop) {
		// t@C^R[h^{o
		sCurrentVolLabel = sVolLabel.SpanExcluding(",");

		// t@C^R[h^{𕪉
		sFileName = sCurrentVolLabel.SpanExcluding("/");
		nNextPos = sFileName.GetLength() + 1;
		sTemp = sCurrentVolLabel.Mid(nNextPos).SpanExcluding("/");
		nRecordLength = atoi(sTemp);
		nNextPos += sTemp.GetLength() + 1;
		nVolume = atoi(sCurrentVolLabel.Mid(nNextPos));

		// Rs[t@C̃pX쐬
		sFileName = CreatePathName(pDirName, sFileName);

		for (i = 0; i < nVolume; i++) {
			// {[{`FbN
			if (nVolCount >= pParam->nVolCount) {
				DispMessage(IDS_MSG_NOTEXIST_DAT, MB_OK, FALSE, sFileName, nRecordLength, nVolume);
				bLoop = FALSE;
				break;
			}

			if (bBOT) {
				// Q߂̃{[ȍ~̊mFbZ[W
				if (DispMessage(IDS_MSG_DEVICE_SET3, MB_OKCANCEL, FALSE,
						pParam->sShubetsuCode, pParam->sShikibetsuCode, sCurrentVolLabel) == IDCANCEL)
					return RC_CANCEL;
			}

			// CMTt@CɃRs[
			if ((nResult = m_MTDriver.ReadFileNonLabel(sFileName)) < 0 || nResult == RESULT_FILE_ERROR)
				return RC_IOERROR;
			else if (nResult == RESULT_FILE_END && i + 1 != nVolume) {
				DispMessage(IDS_MSG_DIFF_VOLNUM, MB_OK, FALSE);
				bLoop = FALSE;
				break;
			} else if (nResult == RESULT_VOLUME_END) {
				nVolCount++;
				bBOT = TRUE;
			}
		}

		// ̃{[xɈړ
		sVolLabel = sVolLabel.Mid(min(sCurrentVolLabel.GetLength() + 1, sVolLabel.GetLength()));
	}

	return RC_NORMAL;
}

//
//	@\	F@G[擾
//
//		F	nErrorCode - G[R[h
//				sErrorMsg - G[e
//
//	Al	F	
//
//	@\F	G[R[hƂ̓eibZ[Wj擾B
//
//	l	F	
//
void CInputCMT::GetError(int &nErrorCode, CString &sErrorMsg)
{
	nErrorCode = m_MTDriver.GetError(sErrorMsg);
}
